#!/usr/bin/env python
import sys
from PyQt4.QtCore import *
from PyQt4.QtGui import *


class BoxItem(QGraphicsItem):

    def __init__(self, position, color, rect):
        super(BoxItem, self).__init__()
        self.setFlags(QGraphicsItem.ItemIsSelectable|
                      QGraphicsItem.ItemIsMovable|
                      QGraphicsItem.ItemIsFocusable)
        self.rect = rect
        self.color = color
        self.setPos(position)
        self.setMatrix(QMatrix())

    def boundingRect(self):
        return self.rect

    def paint(self, painter, option, widget):
        painter.setClipRegion(QRegion(QRect(0, 0, 20, 20)))
        painter.setPen(Qt.NoPen)
        painter.setBrush(QBrush(self.color))
        painter.drawRect(self.rect)

class IntBoxItem(QGraphicsItem):

    def __init__(self, position, color, rect, parent):
        super(IntBoxItem, self).__init__(parent)
        self.setFlags(QGraphicsItem.ItemIsSelectable|
                      QGraphicsItem.ItemIsMovable|
                      QGraphicsItem.ItemIsFocusable)
        self.rect = rect
        self.color = color
        self.setPos(position)
        self.setMatrix(QMatrix())
        self.setOpacity(0.7)

    def boundingRect(self):
        return self.rect

    def paint(self, painter, option, widget):
        painter.setPen(Qt.NoPen)
        painter.setBrush(QBrush(self.color))
        painter.drawRect(self.rect)


class MainForm(QDialog):

    def __init__(self, parent=None):
        super(MainForm, self).__init__(parent)
        self.scene = QGraphicsScene(self)
        self.scene.setSceneRect(0, 0, 200, 200)
        self.view = QGraphicsView()
        self.view.setScene(self.scene)
        
        layout = QVBoxLayout()
        layout.addWidget(self.view)
        self.setLayout(layout)

        self.r1 = BoxItem(QPointF(0, 0), QColor(255, 0, 0), QRectF(0, 0, 100, 100))
        self.r2 = IntBoxItem(QPointF(0, 0), QColor(255, 255, 0), QRectF(0, 0, 50, 50), self.r1)
        self.scene.addItem(self.r1)


app = QApplication(sys.argv)
form = MainForm()
form.show()
app.exec_()
